/*
 * jcurl java curling software framework http://www.jcurl.org Copyright (C)
 * 2005-2009 M. Rohrmoser
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307 USA
 */

package org.jcurl.core.ui;

import java.awt.geom.Point2D;

import org.jcurl.core.api.Rock;
import org.jcurl.core.api.RockSet;
import org.jcurl.core.api.RockType.Pos;

/**
 * Change of a {@link Pos} {@link Rock}.
 * 
 * @author <a href="mailto:m@jcurl.org">M. Rohrmoser </a>
 * @version $Id$
 */
public class PosMemento extends RockMemento<Pos> {

	private static final long serialVersionUID = -4765663817093493740L;

	public PosMemento(final Rock<Pos> context, final int idx16, final Point2D p) {
		super(context, idx16, p);
	}

	private PosMemento(final RockSet<Pos> context, final int idx16,
			final double x, final double y) {
		super(context, idx16, x, y);
	}

	public PosMemento(final RockSet<Pos> context, final int idx16,
			final Point2D p) {
		super(context, idx16, p);
	}

	@Override
	protected Object clone() {
		return new PosMemento(getContext(), idx16, x, y);
	}
}